diff -Nura php-5.0.4/acinclude.m4 hardening-patch-5.0.4-0.4.1/acinclude.m4
--- php-5.0.4/acinclude.m4	2005-01-25 14:02:45.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/acinclude.m4	2005-08-04 12:06:45.000000000 +0200
@@ -1169,6 +1169,36 @@
   fi
 ])
 
+dnl
+dnl Check for broken realpath()
+dnl
+dnl realpath("/etc/hosts/../passwd",XXX) should not return 
+dnl "/etc/passwd"
+dnl
+AC_DEFUN([PHP_AC_BROKEN_REALPATH],[
+  AC_CACHE_CHECK(whether realpath is broken, ac_cv_broken_realpath,[
+    AC_TRY_RUN([
+main() {
+	char buf[4096+1];
+	buf[0] = 0;
+	realpath("/etc/hosts/../passwd", buf);
+	exit(strcmp(buf, "/etc/passwd")==0); 
+}
+    ],[
+      ac_cv_broken_realpath=no
+    ],[
+      ac_cv_broken_realpath=yes
+    ],[
+      ac_cv_broken_realpath=no
+    ])
+  ])
+  if test "$ac_cv_broken_realpath" = "yes"; then
+    AC_DEFINE(PHP_BROKEN_REALPATH, 1, [Whether realpath is broken])
+  else
+    AC_DEFINE(PHP_BROKEN_REALPATH, 0, [Whether realpath is broken])
+  fi
+])
+
 dnl PHP_SHARED_MODULE(module-name, object-var, build-dir, cxx)
 dnl
 dnl Basically sets up the link-stage for building module-name
diff -Nura php-5.0.4/configure.in hardening-patch-5.0.4-0.4.1/configure.in
--- php-5.0.4/configure.in	2005-03-30 23:43:12.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/configure.in	2005-08-04 12:06:45.000000000 +0200
@@ -235,7 +235,7 @@
 sinclude(Zend/acinclude.m4)
 sinclude(Zend/Zend.m4)
 sinclude(TSRM/tsrm.m4)
-
+sinclude(main/hardening_patch.m4)
 
 
 divert(2)
@@ -620,6 +620,7 @@
 AC_FUNC_ALLOCA
 dnl PHP_AC_BROKEN_SPRINTF
 dnl PHP_AC_BROKEN_SNPRINTF
+PHP_AC_BROKEN_REALPATH
 PHP_DECLARED_TIMEZONE
 PHP_TIME_R_TYPE
 PHP_READDIR_R_TYPE
@@ -1262,7 +1263,7 @@
        php_ini.c SAPI.c rfc1867.c php_content_types.c strlcpy.c \
        strlcat.c mergesort.c reentrancy.c php_variables.c php_ticks.c \
        network.c php_open_temporary_file.c php_logos.c \
-       output.c )
+       output.c hardening_patch.c )
 
 PHP_ADD_SOURCES(main/streams, streams.c cast.c memory.c filter.c \
        plain_wrapper.c userspace.c transports.c xp_socket.c mmap.c)
@@ -1280,7 +1281,7 @@
     zend_variables.c zend.c zend_API.c zend_extensions.c zend_hash.c \
     zend_list.c zend_indent.c zend_builtin_functions.c zend_sprintf.c \
     zend_ini.c zend_qsort.c zend_multibyte.c zend_ts_hash.c zend_stream.c \
-    zend_iterators.c zend_interfaces.c zend_exceptions.c zend_strtod.c)
+    zend_iterators.c zend_interfaces.c zend_exceptions.c zend_strtod.c zend_canary.c )
 
 if test -r "$abs_srcdir/Zend/zend_objects.c"; then
   PHP_ADD_SOURCES(Zend, zend_objects.c zend_object_handlers.c zend_objects_API.c zend_mm.c \
diff -Nura php-5.0.4/ext/fbsql/php_fbsql.c hardening-patch-5.0.4-0.4.1/ext/fbsql/php_fbsql.c
--- php-5.0.4/ext/fbsql/php_fbsql.c	2005-02-09 20:32:45.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/fbsql/php_fbsql.c	2005-08-04 12:06:45.000000000 +0200
@@ -1852,8 +1852,24 @@
 	}
 	else if (fbcmdErrorsFound(md))
 	{
+#if HARDENING_PATCH
+		char*	query_copy;
+		int i;
+#endif
 		FBCErrorMetaData* emd = fbcdcErrorMetaData(c, md);
 		char*             emg = fbcemdAllErrorMessages(emd);
+#if HARDENING_PATCH
+		query_copy=estrdup(query_copy);
+		for (i=0; query_copy[i]; i++) if (query_copy[i]<32) query_copy[i]='.';
+		php_security_log(S_SQL, "fbsql error: %s - query: %s", emg, query_copy);
+		efree(query_copy);
+		if (HG(hphp_sql_bailout_on_error)) {
+			free(emg);
+			fbcemdRelease(emd);
+			result = 0;
+			zend_bailout();
+		}
+#endif
 		if (FB_SQL_G(generateWarnings))
 		{
 			if (emg)
diff -Nura php-5.0.4/ext/mysql/php_mysql.c hardening-patch-5.0.4-0.4.1/ext/mysql/php_mysql.c
--- php-5.0.4/ext/mysql/php_mysql.c	2005-02-22 15:59:30.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/mysql/php_mysql.c	2005-08-04 12:06:45.000000000 +0200
@@ -1221,6 +1221,8 @@
 {
 	php_mysql_conn *mysql;
 	MYSQL_RES *mysql_result;
+	char *copy_query;
+	int i;
 	
 	ZEND_FETCH_RESOURCE2(mysql, php_mysql_conn *, mysql_link, link_id, "MySQL-Link", le_link, le_plink);
 	
@@ -1271,6 +1273,13 @@
 				php_error_docref("http://www.mysql.com/doc" TSRMLS_CC, E_WARNING, "%s", mysql_error(&mysql->conn)); 
 			}
 		}
+		copy_query = estrdup(Z_STRVAL_PP(query));
+		for (i=0; copy_query[i]; i++) if (copy_query[i] < 32) copy_query[i]='.';
+		php_security_log(S_SQL, "MySQL error: %s - query: %s", mysql_error(&mysql->conn), copy_query);
+		efree(copy_query);
+		if (HG(hphp_sql_bailout_on_error)) {
+			zend_bailout();
+		}
 		RETURN_FALSE;
 	}
 #else
@@ -1281,6 +1290,13 @@
 				php_error_docref("http://www.mysql.com/doc" TSRMLS_CC, E_WARNING, "%s", mysql_error(&mysql->conn)); 
 			}
 		}
+		copy_query = estrdup(Z_STRVAL_PP(query));
+		for (i=0; copy_query[i]; i++) if (copy_query[i] < 32) copy_query[i]='.';
+		php_security_log(S_SQL, "MySQL error: %s - query: %s", mysql_error(&mysql->conn), copy_query);
+		efree(copy_query);
+		if (HG(hphp_sql_bailout_on_error)) {
+			zend_bailout();
+		}
 		RETURN_FALSE;
 	}
 #endif
diff -Nura php-5.0.4/ext/mysqli/mysqli_nonapi.c hardening-patch-5.0.4-0.4.1/ext/mysqli/mysqli_nonapi.c
--- php-5.0.4/ext/mysqli/mysqli_nonapi.c	2005-02-25 00:59:49.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/mysqli/mysqli_nonapi.c	2005-08-04 12:06:45.000000000 +0200
@@ -228,6 +228,17 @@
 	if (mysql_real_query(mysql->mysql, query, query_len)) {
 		char s_error[MYSQL_ERRMSG_SIZE], s_sqlstate[SQLSTATE_LENGTH+1];
 		unsigned int s_errno;
+#if HARDENING_PATCH
+		char *query_copy = estrdup(query);
+		int i;
+		
+		for (i=0; query_copy[i]; i++) if (query_copy[i]<32) query_copy[i]='.';
+		php_security_log(S_SQL, "MySQLi error: %s - query: %s", mysql->mysql->net.last_errno, query_copy);
+		efree(query_copy);
+		if (HG(hphp_sql_bailout_on_error)) {
+			zend_bailout();
+		}
+#endif
 		MYSQLI_REPORT_MYSQL_ERROR(mysql->mysql);
 
 		/* we have to save error information, cause 
@@ -268,6 +279,17 @@
 	MYSQLI_DISABLE_MQ;
 
 	if (mysql_real_query(mysql->mysql, query, query_len)) {
+#if HARDENING_PATCH
+		char *query_copy = estrdup(query);
+		int i;
+		
+		for (i=0; query_copy[i]; i++) if (query_copy[i]<32) query_copy[i]='.';
+		php_security_log(S_SQL, "MySQLi error: %s - query: %s", mysql->mysql->net.last_errno, query_copy);
+		efree(query_copy);
+		if (HG(hphp_sql_bailout_on_error)) {
+			zend_bailout();
+		}
+#endif
 		MYSQLI_REPORT_MYSQL_ERROR(mysql->mysql);
 		RETURN_FALSE;
 	}
diff -Nura php-5.0.4/ext/pgsql/pgsql.c hardening-patch-5.0.4-0.4.1/ext/pgsql/pgsql.c
--- php-5.0.4/ext/pgsql/pgsql.c	2004-05-12 18:49:47.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/ext/pgsql/pgsql.c	2005-08-04 12:06:45.000000000 +0200
@@ -1076,10 +1076,28 @@
 		case PGRES_EMPTY_QUERY:
 		case PGRES_BAD_RESPONSE:
 		case PGRES_NONFATAL_ERROR:
-		case PGRES_FATAL_ERROR:
-			PHP_PQ_ERROR("Query failed: %s", pgsql);
-			PQclear(pgsql_result);
-			RETURN_FALSE;
+		case PGRES_FATAL_ERROR: 
+			{
+#if HARDENING_PATCH
+				int i;
+				char *query_copy;
+#endif				
+				char *msgbuf = _php_pgsql_trim_message(PQerrorMessage(pgsql), NULL);
+				PQclear(pgsql_result);
+#if HARDENING_PATCH
+				query_copy = estrdup(Z_STRVAL_PP(query));
+				for (i=0; query_copy[i]; i++) if (query_copy[i]<32) query_copy[i]='.';
+				php_security_log(S_SQL, "PgSQL error: %s - query: %s", msgbuf, query_copy);
+				efree(query_copy);
+				if (HG(hphp_sql_bailout_on_error)) {
+					efree(msgbuf);
+					zend_bailout();
+				}
+#endif				
+				php_error_docref(NULL TSRMLS_CC, E_WARNING, "Query failed: %s", msgbuf);
+				efree(msgbuf);
+				RETURN_FALSE;
+			}
 			break;
 		case PGRES_COMMAND_OK: /* successful command that did not return rows */
 		default:
diff -Nura php-5.0.4/ext/sqlite/sqlite.c hardening-patch-5.0.4-0.4.1/ext/sqlite/sqlite.c
--- php-5.0.4/ext/sqlite/sqlite.c	2004-09-26 03:41:40.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/ext/sqlite/sqlite.c	2005-08-04 12:06:45.000000000 +0200
@@ -1473,6 +1473,19 @@
 	db->last_err_code = ret;
 
 	if (ret != SQLITE_OK) {
+#if HARDENING_PATCH
+		char *query_copy;
+		int i;
+
+		query_copy = estrdup(sql);
+		for (i=0; query_copy[i]; i++) if (query_copy[i]<32) query_copy[i]='.';
+		php_security_log(S_SQL, "SQLite error: %s - query: %s", errtext, query_copy);
+		efree(query_copy);
+		if (HG(hphp_sql_bailout_on_error)) {
+			sqlite_freemem(errtext);
+			zend_bailout();
+		}
+#endif
 		php_error_docref(NULL TSRMLS_CC, E_WARNING, "%s", errtext);
 		sqlite_freemem(errtext);
 		goto terminate;
diff -Nura php-5.0.4/ext/standard/array.c hardening-patch-5.0.4-0.4.1/ext/standard/array.c
--- php-5.0.4/ext/standard/array.c	2005-03-12 11:12:49.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/standard/array.c	2005-08-04 12:06:45.000000000 +0200
@@ -1255,6 +1255,32 @@
 			}
 		}
 	}
+
+	if (var_name[0] == 'H') {
+		if ((strcmp(var_name, "HTTP_GET_VARS")==0)||
+		    (strcmp(var_name, "HTTP_POST_VARS")==0)||
+		    (strcmp(var_name, "HTTP_POST_FILES")==0)||
+		    (strcmp(var_name, "HTTP_ENV_VARS")==0)||
+		    (strcmp(var_name, "HTTP_SERVER_VARS")==0)||
+		    (strcmp(var_name, "HTTP_SESSION_VARS")==0)||
+		    (strcmp(var_name, "HTTP_COOKIE_VARS")==0)||
+		    (strcmp(var_name, "HTTP_RAW_POST_DATA")==0)) {
+		    return 0;
+		}
+	} else if (var_name[0] == '_') {
+		if ((strcmp(var_name, "_COOKIE")==0)||
+		    (strcmp(var_name, "_ENV")==0)||
+		    (strcmp(var_name, "_FILES")==0)||
+		    (strcmp(var_name, "_GET")==0)||
+		    (strcmp(var_name, "_POST")==0)||
+		    (strcmp(var_name, "_REQUEST")==0)||
+		    (strcmp(var_name, "_SESSION")==0)||
+		    (strcmp(var_name, "_SERVER")==0)) {
+		    return 0;
+		}
+	} else if (strcmp(var_name, "GLOBALS")==0) {
+		return 0;
+	}
 	
 	return 1;
 }
diff -Nura php-5.0.4/ext/standard/basic_functions.c hardening-patch-5.0.4-0.4.1/ext/standard/basic_functions.c
--- php-5.0.4/ext/standard/basic_functions.c	2005-03-10 13:10:57.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/standard/basic_functions.c	2005-08-06 10:33:50.000000000 +0200
@@ -142,12 +142,14 @@
 typedef struct _php_shutdown_function_entry {
 	zval **arguments;
 	int arg_count;
+	zend_bool created_by_eval;
 } php_shutdown_function_entry;
 
 typedef struct _user_tick_function_entry {
 	zval **arguments;
 	int arg_count;
 	int calling;
+	zend_bool created_by_eval;
 } user_tick_function_entry;
 
 /* some prototypes for local functions */
@@ -617,7 +619,7 @@
 	PHP_FALIAS(socket_get_status, stream_get_meta_data,						NULL)
 
 #if (!defined(__BEOS__) && !defined(NETWARE) && HAVE_REALPATH) || defined(ZTS)
-	PHP_FE(realpath,														NULL)
+	PHP_STATIC_FE("realpath",		zif_real_path,							NULL)
 #endif
 
 #ifdef HAVE_FNMATCH
@@ -2103,7 +2105,13 @@
 static int user_shutdown_function_call(php_shutdown_function_entry *shutdown_function_entry TSRMLS_DC)
 {
 	zval retval;
+#if HARDENING_PATCH	
+	zend_uint orig_code_type = EG(in_code_type);
 
+	if (shutdown_function_entry->created_by_eval) {
+		EG(in_code_type) = ZEND_EVAL_CODE;
+	}
+#endif
 	if (call_user_function(	EG(function_table), NULL,
 							shutdown_function_entry->arguments[0],
 							&retval, 
@@ -2115,6 +2123,9 @@
 	} else {
 		php_error_docref(NULL TSRMLS_CC, E_WARNING, "Unable to call %s() - function does not exist", Z_STRVAL_P(shutdown_function_entry->arguments[0]));
 	}
+#if HARDENING_PATCH	
+	EG(in_code_type) = orig_code_type;
+#endif
 	return 0;
 }
 
@@ -2122,6 +2133,13 @@
 {
 	zval retval;
 	zval *function = tick_fe->arguments[0];
+#if HARDENING_PATCH	
+	zend_uint orig_code_type = EG(in_code_type);
+
+	if (tick_fe->created_by_eval) {
+		EG(in_code_type) = ZEND_EVAL_CODE;
+	}
+#endif
 	
 	/* Prevent reentrant calls to the same user ticks function */
 	if (! tick_fe->calling) {
@@ -2153,6 +2171,9 @@
 	
 		tick_fe->calling = 0;
 	}
+#if HARDENING_PATCH	
+	EG(in_code_type) = orig_code_type;
+#endif
 }
 
 static void run_user_tick_functions(int tick_count)
@@ -2215,6 +2236,13 @@
 	}
 
 	shutdown_function_entry.arguments = (pval **) safe_emalloc(sizeof(pval *), shutdown_function_entry.arg_count, 0);
+#if HARDENING_PATCH
+	if (EG(in_code_type)==ZEND_EVAL_CODE) {
+		shutdown_function_entry.created_by_eval = 1;
+	} else {
+		shutdown_function_entry.created_by_eval = 0;
+	}
+#endif	
 
 	if (zend_get_parameters_array(ht, shutdown_function_entry.arg_count, shutdown_function_entry.arguments) == FAILURE) {
 		RETURN_FALSE;
@@ -2836,6 +2864,13 @@
 	}
 
 	tick_fe.arguments = (zval **) safe_emalloc(sizeof(zval *), tick_fe.arg_count, 0);
+#if HARDENING_PATCH
+	if (EG(in_code_type)==ZEND_EVAL_CODE) {
+		tick_fe.created_by_eval = 1;
+	} else {
+		tick_fe.created_by_eval = 0;
+	}
+#endif	
 
 	if (zend_get_parameters_array(ht, tick_fe.arg_count, tick_fe.arguments) == FAILURE) {
 		RETURN_FALSE;
@@ -3124,6 +3159,35 @@
 	memcpy(new_key, prefix, prefix_len);
 	memcpy(new_key+prefix_len, hash_key->arKey, hash_key->nKeyLength);
 
+	if (new_key[0] == 'H') {
+		if ((strcmp(new_key, "HTTP_GET_VARS")==0)||
+		    (strcmp(new_key, "HTTP_POST_VARS")==0)||
+		    (strcmp(new_key, "HTTP_POST_FILES")==0)||
+		    (strcmp(new_key, "HTTP_ENV_VARS")==0)||
+		    (strcmp(new_key, "HTTP_SERVER_VARS")==0)||
+		    (strcmp(new_key, "HTTP_SESSION_VARS")==0)||
+		    (strcmp(new_key, "HTTP_COOKIE_VARS")==0)||
+		    (strcmp(new_key, "HTTP_RAW_POST_DATA")==0)) {
+		    efree(new_key);
+		    return 0;
+		}
+	} else if (new_key[0] == '_') {
+		if ((strcmp(new_key, "_COOKIE")==0)||
+		    (strcmp(new_key, "_ENV")==0)||
+		    (strcmp(new_key, "_FILES")==0)||
+		    (strcmp(new_key, "_GET")==0)||
+		    (strcmp(new_key, "_POST")==0)||
+		    (strcmp(new_key, "_REQUEST")==0)||
+		    (strcmp(new_key, "_SESSION")==0)||
+		    (strcmp(new_key, "_SERVER")==0)) {
+		    efree(new_key);
+		    return 0;
+		}
+	} else if (strcmp(new_key, "GLOBALS")==0) {
+		efree(new_key);
+		return 0;
+	}
+
 	zend_hash_del(&EG(symbol_table), new_key, new_key_len);
 	ZEND_SET_SYMBOL_WITH_LENGTH(&EG(symbol_table), new_key, new_key_len, *var, (*var)->refcount+1, 0);
 
diff -Nura php-5.0.4/ext/standard/dl.c hardening-patch-5.0.4-0.4.1/ext/standard/dl.c
--- php-5.0.4/ext/standard/dl.c	2005-03-21 09:34:37.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/standard/dl.c	2005-08-04 20:28:21.000000000 +0200
@@ -177,8 +177,35 @@
 		RETURN_FALSE;
 	}
 	module_entry = get_module();
+
+	/* check if Hardening-Patch is installed */
+	if (module_entry->zend_api < 1000000000) {
+		php_error_docref(NULL TSRMLS_CC, error_type,
+				  "%s: Unable to initialize module\n"
+				  "Module compiled without Hardening-Patch, module API=%d, debug=%d, thread-safety=%d\n"
+				  "PHP    compiled with Hardening-Patch=%d, module API=%d, debug=%d, thread-safety=%d\n"
+				  "These options need to match\n",
+				  module_entry->name, module_entry->zend_api, module_entry->zend_debug, module_entry->zts,
+				  HARDENING_PATCH_ZEND_MODULE_API_NO, ZEND_MODULE_API_NO, ZEND_DEBUG, USING_ZTS);
+		DL_UNLOAD(handle);
+		RETURN_FALSE;
+	}
+
+	/* check if correct Hardening-Patch is installed */
+	if (module_entry->zend_api != HARDENING_PATCH_ZEND_MODULE_API_NO) {
+		php_error_docref(NULL TSRMLS_CC, error_type,
+				  "%s: Unable to initialize module\n"
+				  "Module compiled with Hardening-Patch=%d, module API=%d, debug=%d, thread-safety=%d\n"
+				  "PHP    compiled with Hardening-Patch=%d, module API=%d, debug=%d, thread-safety=%d\n"
+				  "These options need to match\n",
+				  module_entry->name, module_entry->zend_api, module_entry->real_zend_api, module_entry->zend_debug, module_entry->zts,
+				  HARDENING_PATCH_ZEND_MODULE_API_NO, ZEND_MODULE_API_NO, ZEND_DEBUG, USING_ZTS);
+		DL_UNLOAD(handle);
+		RETURN_FALSE;
+	}
+
 	if ((module_entry->zend_debug != ZEND_DEBUG) || (module_entry->zts != USING_ZTS)
-		|| (module_entry->zend_api != ZEND_MODULE_API_NO)) {
+		|| (module_entry->real_zend_api != ZEND_MODULE_API_NO)) {
 		/* Check for pre-4.1.0 module which has a slightly different module_entry structure :( */
 			struct pre_4_1_0_module_entry {
 				  char *name;
@@ -212,7 +239,7 @@
 				zts        = ((struct pre_4_1_0_module_entry *)module_entry)->zts; 
 			} else {			
 				name       = module_entry->name;
-				zend_api   = module_entry->zend_api;
+				zend_api   = module_entry->real_zend_api;
 				zend_debug = module_entry->zend_debug;
 				zts        = module_entry->zts; 
 			}
diff -Nura php-5.0.4/ext/standard/file.c hardening-patch-5.0.4-0.4.1/ext/standard/file.c
--- php-5.0.4/ext/standard/file.c	2005-03-27 17:53:30.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/ext/standard/file.c	2005-08-04 12:06:45.000000000 +0200
@@ -2044,7 +2044,7 @@
 #if (!defined(__BEOS__) && !defined(NETWARE) && HAVE_REALPATH) || defined(ZTS)
 /* {{{ proto string realpath(string path)
    Return the resolved path */
-PHP_FUNCTION(realpath)
+PHP_FUNCTION(real_path)
 {
 	zval **path;
 	char resolved_path_buff[MAXPATHLEN];
diff -Nura php-5.0.4/ext/standard/file.h hardening-patch-5.0.4-0.4.1/ext/standard/file.h
--- php-5.0.4/ext/standard/file.h	2004-06-21 23:08:05.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/ext/standard/file.h	2005-08-04 12:06:45.000000000 +0200
@@ -60,7 +60,7 @@
 PHP_FUNCTION(fd_set);
 PHP_FUNCTION(fd_isset);
 #if (!defined(__BEOS__) && !defined(NETWARE) && HAVE_REALPATH) || defined(ZTS)
-PHP_FUNCTION(realpath);
+PHP_FUNCTION(real_path);
 PHP_FUNCTION(fnmatch);
 #endif
 PHP_NAMED_FUNCTION(php_if_ftruncate);
diff -Nura php-5.0.4/ext/standard/ftp_fopen_wrapper.c hardening-patch-5.0.4-0.4.1/ext/standard/ftp_fopen_wrapper.c
--- php-5.0.4/ext/standard/ftp_fopen_wrapper.c	2005-03-21 09:42:34.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/standard/ftp_fopen_wrapper.c	2005-08-04 12:06:45.000000000 +0200
@@ -113,7 +113,7 @@
 {
 	php_stream *stream = NULL, *reuseid = NULL;
 	php_url *resource = NULL;
-	int result, use_ssl, use_ssl_on_data = 0;
+	int result, use_ssl, use_ssl_on_data = 0, tmp_len;
 	char *scratch;
 	char tmp_line[512];
 
@@ -206,10 +206,25 @@
 #endif
 	}
 
+#define PHP_FTP_CNTRL_CHK(val, val_len, err_msg) {	\
+	unsigned char *s = val, *e = s + val_len;	\
+	while (s < e) {	\
+		if (iscntrl(*s)) {	\
+			php_stream_wrapper_log_error(wrapper, options TSRMLS_CC, err_msg, val);	\
+			goto connect_errexit;	\
+		}	\
+		s++;	\
+	}	\
+}
+
 	/* send the user name */
 	php_stream_write_string(stream, "USER ");
 	if (resource->user != NULL) {
-		php_raw_url_decode(resource->user, strlen(resource->user));
+		unsigned char *s, *e;
+		tmp_len = php_raw_url_decode(resource->user, strlen(resource->user));
+		
+		PHP_FTP_CNTRL_CHK(resource->user, tmp_len, "Invalid login %s")
+		
 		php_stream_write_string(stream, resource->user);
 	} else {
 		php_stream_write_string(stream, "anonymous");
@@ -225,7 +240,10 @@
 
 		php_stream_write_string(stream, "PASS ");
 		if (resource->pass != NULL) {
-			php_raw_url_decode(resource->pass, strlen(resource->pass));
+			tmp_len = php_raw_url_decode(resource->pass, strlen(resource->pass));
+		
+			PHP_FTP_CNTRL_CHK(resource->pass, tmp_len, "Invalid password %s")
+			
 			php_stream_write_string(stream, resource->pass);
 		} else {
 			/* if the user has configured who they are,
diff -Nura php-5.0.4/ext/standard/head.c hardening-patch-5.0.4-0.4.1/ext/standard/head.c
--- php-5.0.4/ext/standard/head.c	2005-01-07 22:16:00.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/standard/head.c	2005-08-04 12:06:45.000000000 +0200
@@ -45,10 +45,31 @@
 {
 	zend_bool rep = 1;
 	sapi_header_line ctr = {0};
+#if HARDENING_PATCH
+	int i;
+#endif
 	
 	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s|bl", &ctr.line,
 				&ctr.line_len, &rep, &ctr.response_code) == FAILURE)
 		return;
+
+#if HARDENING_PATCH
+	if (!HG(hphp_multiheader)) {
+		for (i=0; i<ctr.line_len; i++) {
+			if (ctr.line[i]==0) {
+				php_security_log(S_MISC, "header(): headerline truncated by an ASCII-NUL char");
+				ctr.line_len=i;
+				break;
+			} else if (ctr.line[i]=='\n') {
+				if (i>0 && (i<ctr.line_len-1) && (ctr.line[i+1]==' ' || ctr.line[i+1]=='\t')) {
+					continue;
+				}
+				php_security_log(S_MISC, "header(): headerline contains more than one header");
+				ctr.line_len=i;
+			}
+		}
+	}
+#endif
 	
 	sapi_header_op(rep ? SAPI_HEADER_REPLACE:SAPI_HEADER_ADD, &ctr TSRMLS_CC);
 }
diff -Nura php-5.0.4/ext/standard/info.c hardening-patch-5.0.4-0.4.1/ext/standard/info.c
--- php-5.0.4/ext/standard/info.c	2004-05-02 15:23:30.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/ext/standard/info.c	2005-08-04 12:06:45.000000000 +0200
@@ -394,7 +394,7 @@
 
 	if (flag & PHP_INFO_GENERAL) {
 		char *zend_version = get_zend_version();
-		char temp_api[10];
+		char temp_api[11];
 		char *logo_guid;
 
 		php_uname = php_get_uname('a');
@@ -415,11 +415,22 @@
 			PUTS("\" alt=\"PHP Logo\" /></a>");
 		}
 
+#if HARDENING_PATCH
+		if (!sapi_module.phpinfo_as_text) {
+			php_printf("<h1 class=\"p\">PHP Version %s with Hardening-Patch %s</h1>\n", PHP_VERSION, HARDENING_PATCH_VERSION);
+		} else {
+			char temp_ver[40];	
+		
+			snprintf(temp_ver, sizeof(temp_ver), "%s/%s", PHP_VERSION, HARDENING_PATCH_VERSION);
+			php_info_print_table_row(2, "PHP/Hardening-Patch Version", temp_ver);
+		}
+#else
 		if (!sapi_module.phpinfo_as_text) {
 			php_printf("<h1 class=\"p\">PHP Version %s</h1>\n", PHP_VERSION);
 		} else {
 			php_info_print_table_row(2, "PHP Version", PHP_VERSION);
-		}	
+		}
+#endif
 		php_info_print_box_end();
 		php_info_print_table_start();
 		php_info_print_table_row(2, "System", php_uname );
diff -Nura php-5.0.4/ext/standard/syslog.c hardening-patch-5.0.4-0.4.1/ext/standard/syslog.c
--- php-5.0.4/ext/standard/syslog.c	2004-07-30 16:39:18.000000000 +0200
+++ hardening-patch-5.0.4-0.4.1/ext/standard/syslog.c	2005-08-04 12:06:45.000000000 +0200
@@ -42,6 +42,7 @@
  */
 PHP_MINIT_FUNCTION(syslog)
 {
+#if !HARDENING_PATCH
 	/* error levels */
 	REGISTER_LONG_CONSTANT("LOG_EMERG", LOG_EMERG, CONST_CS | CONST_PERSISTENT); /* system unusable */
 	REGISTER_LONG_CONSTANT("LOG_ALERT", LOG_ALERT, CONST_CS | CONST_PERSISTENT); /* immediate action required */
@@ -97,7 +98,7 @@
 	/* AIX doesn't have LOG_PERROR */
 	REGISTER_LONG_CONSTANT("LOG_PERROR", LOG_PERROR, CONST_CS | CONST_PERSISTENT); /*log to stderr*/
 #endif
-
+#endif
 	return SUCCESS;
 }
 /* }}} */
diff -Nura php-5.0.4/ext/varfilter/config.m4 hardening-patch-5.0.4-0.4.1/ext/varfilter/config.m4
--- php-5.0.4/ext/varfilter/config.m4	1970-01-01 01:00:00.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/varfilter/config.m4	2005-08-04 12:06:45.000000000 +0200
@@ -0,0 +1,11 @@
+dnl
+dnl $Id: config.m4,v 1.1 2004/11/14 13:27:16 ionic Exp $
+dnl
+
+PHP_ARG_ENABLE(varfilter, whether to enable Hardening-Patch's variable filter,
+[  --disable-varfilter     Disable Hardening-Patch's variable filter], yes)
+
+if test "$PHP_VARFILTER" != "no"; then
+  AC_DEFINE(HAVE_VARFILTER, 1, [ ])
+  PHP_NEW_EXTENSION(varfilter, varfilter.c, $ext_shared)
+fi
diff -Nura php-5.0.4/ext/varfilter/CREDITS hardening-patch-5.0.4-0.4.1/ext/varfilter/CREDITS
--- php-5.0.4/ext/varfilter/CREDITS	1970-01-01 01:00:00.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/varfilter/CREDITS	2005-08-04 12:06:45.000000000 +0200
@@ -0,0 +1,2 @@
+varfilter
+Stefan Esser
\ Kein Zeilenumbruch am Dateiende.
diff -Nura php-5.0.4/ext/varfilter/php_varfilter.h hardening-patch-5.0.4-0.4.1/ext/varfilter/php_varfilter.h
--- php-5.0.4/ext/varfilter/php_varfilter.h	1970-01-01 01:00:00.000000000 +0100
+++ hardening-patch-5.0.4-0.4.1/ext/varfilter/php_varfilter.h	2005-08-04 12:54:06.000000000 +0200
@@ -0,0 +1,111 @@
+/*
+  +----------------------------------------------------------------------+
+  | Hardened-PHP Project's varfilter extension                           |
+  +----------------------------------------------------------------------+
+  | Copyright (c) 2004-2005 Stefan Esser                                 |
+  +----------------------------------------------------------------------+
+  | This source file is subject to version 2.02 of the PHP license,      |
+  | that is bundled with this package in the file LICENSE, and is        |
+  | available at through the world-wide-web at                           |
+  | http://www.php.net/license/2_02.txt.                                 |
+  | If you did not receive a copy of the PHP license and are unable to   |
+  | obtain it through the world-wide-web, please send a note to          |
+  | license@php.net so we can mail you a copy immediately.               |
+  +----------------------------------------------------------------------+
+  | Author: Stefan Esser <sesser@hardened-php.net>                       |
+  +----------------------------------------------------------------------+
+
+  $Id: php_varfilter.h,v 1.1 2004/11/14 13:27:16 ionic Exp $ 
+*/
+
+#ifndef PHP_VARFILTER_H
+#define PHP_VARFILTER_H
+
+extern zend_module_entry varfilter_module_entry;
+#define phpext_varfilter_ptr &varfilter_module_entry
+
+#ifdef PHP_WIN32
+#define PHP_VARFILTER_API __declspec(dllexport)
+#else
+#define PHP_VARFILTER_API
+#endif
+
+#ifdef ZTS
+#include "TSRM.h"
+#endif
+
+#include "SAPI.h"
+
+#include "php_variables.h"
+
+
+PHP_MINIT_FUNCTION(varfilter);
+PHP_MSHUTDOWN_FUNCTION(varfilter);
+PHP_RINIT_FUNCTION(varfilter);
+PHP_RSHUTDOWN_FUNCTION(varfilter);
+PHP_MINFO_FUNCTION(varfilter);
+
+
+ZEND_BEGIN_MODULE_GLOBALS(varfilter)
+/*	request variables */
+	long  max_request_variables;
+	long  cur_request_variables;
+	long  max_varname_length;
+	long  max_totalname_length;
+	long  max_value_length;
+	long  max_array_depth;
+	long  max_array_index_length;
+/*	cookie variables */
+	long  max_cookie_vars;
+	long  cur_cookie_vars;
+	long  max_cookie_name_length;
+	long  max_cookie_totalname_length;
+	long  max_cookie_value_length;
+	long  max_cookie_array_depth;
+	long  max_cookie_array_index_length;
+/*	get variables */
+	long  max_get_vars;
+	long  cur_get_vars;
+	long  max_get_name_length;
+	long  max_get_totalname_length;
+	long  max_get_value_length;
+	long  max_get_array_depth;
+	long  max_get_array_index_length;
+/*	post variables */
+	long  max_post_vars;
+	long  cur_post_vars;
+	long  max_post_name_length;
+	long  max_post_totalname_length;
+	long  max_post_value_length;
+	long  max_post_array_depth;
+	long  max_post_array_index_length;
+/*	fileupload */
+	long  max_uploads;
+	long  cur_uploads;
+	zend_bool  disallow_elf_files;
+	char *verification_script;
+	
+ZEND_END_MODULE_GLOBALS(varfilter)
+
+
+#ifdef ZTS
+#define VARFILTER_G(v) TSRMG(varfilter_globals_id, zend_varfilter_globals *, v)
+#else
+#define VARFILTER_G(v) (varfilter_globals.v)
+#endif
+
+SAPI_INPUT_FILTER_FUNC(varfilter_input_filter);
+SAPI_PRE_UPLOAD_FILTER_FUNC(varfilter_pre_upload_filter);
+SAPI_UPLOAD_CONTENT_FILTER_FUNC(varfilter_upload_content_filter);
+SAPI_POST_UPLOAD_FILTER_FUNC(varfilter_post_upload_filter);
+
+#endif	/* PHP_VARFILTER_H */
+
+
+/*
+ * Local variables:
+ * tab-width: 4
+ * c-basic-offset: 4
+ * indent-tabs-mode: t
+ * End:
+ */
